import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikIconProps.dart';

import '../../components/UikIcon.dart';
import '../../props/UikTextProps.dart';
import '../../props/UikListTileProps.dart';

UikListTileProps $UikListTilePropsFromJson(Map<String, dynamic> json) {
  final UikListTileProps uikListTileProps = UikListTileProps();

  final String? id = jsonConvert.convert<String>(json['id']);

  final double? leftPadding = jsonConvert.convert<double>(json["leftPadding"]);
  final double? rightPadding =
      jsonConvert.convert<double>(json["rightPadding"]);
  final double? topPadding = jsonConvert.convert<double>(json["topPadding"]);
  final double? bottomPadding =
      jsonConvert.convert<double>(json["bottomPadding"]);

  final double? leftMargin = jsonConvert.convert<double>(json["leftMargin"]);
  final double? rightMargin = jsonConvert.convert<double>(json["rightMargin"]);
  final double? topMargin = jsonConvert.convert<double>(json["topMargin"]);
  final double? bottomMargin =
      jsonConvert.convert<double>(json["bottomMargin"]);

  final String? backgroundColor =
      jsonConvert.convert<String>(json["backgroundColor"]);

  final String? leading = jsonConvert.convert<String>(json["leading"]);
  final String? title = jsonConvert.convert<String>(json["title"]);
  final String? subtitle = jsonConvert.convert<String>(json["subtitle"]);
  final String? trailing = jsonConvert.convert<String>(json["trailing"]);

  if (id != null) {
    uikListTileProps.id = id;
  }

  if (leftPadding != null) {
    uikListTileProps.leftPadding = leftPadding;
  }

  if (rightPadding != null) {
    uikListTileProps.rightPadding = rightPadding;
  }

  if (topPadding != null) {
    uikListTileProps.topPadding = topPadding;
  }

  if (bottomPadding != null) {
    uikListTileProps.bottomPadding = bottomPadding;
  }

  if (leftMargin != null) {
    uikListTileProps.leftMargin = leftMargin;
  }

  if (rightMargin != null) {
    uikListTileProps.rightMargin = rightMargin;
  }

  if (topMargin != null) {
    uikListTileProps.topMargin = topMargin;
  }

  if (bottomMargin != null) {
    uikListTileProps.bottomMargin = bottomMargin;
  }

  if (backgroundColor != null) {
    uikListTileProps.backgroundColor = backgroundColor;
  }

  if (leading != null) {
    uikListTileProps.leading =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json["leading"]));
  } else {
    uikListTileProps.leading = null;
  }

  if (title != null) {
    uikListTileProps.title =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['title']));
  } else {
    uikListTileProps.title = null;
  }

  if (subtitle != null) {
    uikListTileProps.subtitle =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['subtitle']));
  } else {
    uikListTileProps.subtitle = null;
  }

  if (trailing != null) {
    uikListTileProps.trailing =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json["trailing"]));
  } else {
    uikListTileProps.trailing = null;
  }

  return uikListTileProps;
}

Map<String, dynamic> $UikListTilePropsToJson(UikListTileProps entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  // data['src'] = entity.src;
  // data['action'] = entity.action.toJson();
  return data;
}
