import 'package:ui_sdk/components/UikHomeCardSix.dart';
import 'package:ui_sdk/components/UikProductCardBig.dart';

import 'package:ui_sdk/components/UikProductImageTitlePriceCard.dart';
//import 'package:ui_sdk/components/UikProductCardBig.dart';

import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikProductCardBigProps.dart';
import 'package:ui_sdk/props/UikProductCardGridProps.dart';

import '../../components/UikHomeCardTen.dart';

import 'package:ui_sdk/props/UikProductImageTitlePriceCardProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

import '../../components/UikHomeCardTwo.dart';
import '../../components/WidgetType.dart';
import '../../props/UikHomeCardSixProps.dart';
import '../../props/UikHomeCardTenProps.dart';
import '../../props/UikHomeCardTwoProps.dart';

UikProductCardGridProps $UikProductCardGridPropsFromJson(
    Map<String, dynamic> json) {
  final UikProductCardGridProps uikProductCardGridProps =
      UikProductCardGridProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikProductCardGridProps.id = id;
  }

  final List<dynamic>? productCards =
      jsonConvert.convert<List<dynamic>>(json['productCards']);
  // print(productCards);
  if (productCards != null) {
    for (int i = 0; i < productCards.length; i++) {
      if (json['productCards'][i]['id'] == 'productCard') {
        uikProductCardGridProps.productCards.add(UikProductImageTitlePriceCard(
            WidgetType.UikText,
            UikProductImageTitlePriceCardProps.fromJson(productCards[i])));
      } else if (json['productCards'][0]['id'] == 'HomeCardSix') {
        uikProductCardGridProps.productCards.add(
          UikHomeCardSix(
            WidgetType.UikText,
            UikHomeCardSixProps.fromJson(productCards[i]),
          ),
        );
      } else if (json['productCards'][0]['id'] == 'HomeCardTen') {
        uikProductCardGridProps.productCards.add(
          UikHomeCardTen(
            WidgetType.UikText,
            UikHomeCardTenProps.fromJson(productCards[i]),
          ),
        );
      } else if (json['productCards'][0]['id'] == 'HomeCardTwo') {
        uikProductCardGridProps.productCards.add(
          UikHomeCardTwo(
            WidgetType.UikText,
            UikHomeCardTwoProps.fromJson(productCards[i]),
          ),
        );
      } else {
        uikProductCardGridProps.productCards.add(
          UikProductCardBig(
            WidgetType.UikText,
            UikProductCardBigProps.fromJson(productCards[i]),
          ),
        );
      }
    }
    // print(productCards.length);
  }

  final double? gridWidth = jsonConvert.convert<double>(json['gridWidth']);
  if (gridWidth != null) {
    uikProductCardGridProps.gridWidth = gridWidth;
  }

  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikProductCardGridProps.topMargin = topMargin;
  }
  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikProductCardGridProps.leftMargin = leftMargin;
  }
  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikProductCardGridProps.rightMargin = rightMargin;

    final double? gridHeight = jsonConvert.convert<double>(json['gridHeight']);
    if (gridHeight != null) {
      uikProductCardGridProps.gridHeight = gridHeight;
    }
    // print(gridWidth);

    final double? childAspectRatio =
        jsonConvert.convert<double>(json['childAspectRatio']);
    if (childAspectRatio != null) {
      uikProductCardGridProps.childAspectRatio = childAspectRatio;
    }

    final int? crossAxisCount =
        jsonConvert.convert<int>(json['crossAxisCount']);
    if (crossAxisCount != null) {
      uikProductCardGridProps.crossAxisCount = crossAxisCount;
    }

    final double? leftPadding =
        jsonConvert.convert<double>(json['leftPadding']);
    if (leftPadding != null) {
      uikProductCardGridProps.leftPadding = leftPadding;
    }

    final double? rightPadding =
        jsonConvert.convert<double>(json['rightPadding']);
    if (rightPadding != null) {
      uikProductCardGridProps.rightPadding = rightPadding;
    }

    final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
    if (action != null) {
      uikProductCardGridProps.action = action;
    }
  }
  return uikProductCardGridProps;
}

Map<String, dynamic> $UikProductCardGridPropsToJson(
    UikProductCardGridProps entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['action'] = entity.action.toJson();
  return data;
}
