import 'dart:ui';

import 'package:ui_sdk/components/UikStepper.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';

import '../../components/UikButton.dart';
import '../../components/UikChips.dart';
import '../../components/UikContainerText.dart';
import '../../components/UikIcon.dart';
import '../../components/UikText.dart';
import '../../components/WidgetType.dart';
import '../../components/uikTextChip.dart';
import '../../props/UikChipsProps.dart';
import '../../props/UikContainerTextProps.dart';
import '../../props/UikIconProps.dart';

import '../../components/UikIcon.dart';
import '../../components/WidgetType.dart';
import '../../props/UikIconProps.dart';
import '../../props/UikStepperProps.dart';
import '../../props/UikTextChipProps.dart';
import '../../props/UikTextProps.dart';
import '../../props/UikTwoComponentRowProps.dart';

UikTwoComponentRowProps $UikTwoComponentRowPropsFromJson(
    Map<String, dynamic> json) {
  final UikTwoComponentRowProps uikTwoComponentRowProps =
      UikTwoComponentRowProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikTwoComponentRowProps.id = id;
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikTwoComponentRowProps.action = action;
  }

  final String? firstComponent =
      jsonConvert.convert<String>(json['firstComponent']);
  if (firstComponent != null) {
    if (json['firstComponent']["id"] == "text") {
      uikTwoComponentRowProps.firstComponent = UikContainerText(
          WidgetType.UikContainerText,
          UikContainerTextProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "stepper") {
      uikTwoComponentRowProps.firstComponent = UikStepper(
          WidgetType.UikText, UikStepperProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "button") {
      uikTwoComponentRowProps.firstComponent = UikButton(WidgetType.UikButton,
          UikButtonProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "chip") {
      uikTwoComponentRowProps.firstComponent = UikTextChip(WidgetType.UikText,
          UikTextChipProps.fromJson(json['firstComponent']));
    }
  }

  final String? secondComponent =
      jsonConvert.convert<String>(json['secondComponent']);
  if (secondComponent != null) {
    if (json['secondComponent']["id"] == "text") {
      uikTwoComponentRowProps.secondComponent = UikContainerText(
          WidgetType.UikContainerText,
          UikContainerTextProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "stepper") {
      uikTwoComponentRowProps.secondComponent = UikStepper(WidgetType.UikText,
          UikStepperProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "button") {
      uikTwoComponentRowProps.secondComponent = UikButton(WidgetType.UikButton,
          UikButtonProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "chip") {
      uikTwoComponentRowProps.secondComponent = UikTextChip(WidgetType.UikText,
          UikTextChipProps.fromJson(json['secondComponent']));
    }
  }

  final double? leftMargin = jsonConvert.convert<double>(json['marginLeft']);
  if (leftMargin != null) {
    uikTwoComponentRowProps.marginLeft = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json['marginRight']);
  if (rightMargin != null) {
    uikTwoComponentRowProps.marginRight = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json['marginTop']);
  if (topMargin != null) {
    uikTwoComponentRowProps.marginTop = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['marginBottom']);
  if (bottomMargin != null) {
    uikTwoComponentRowProps.marginBottom = bottomMargin;
  }
  return uikTwoComponentRowProps;
}

Map<String, dynamic> $UikTwoComponentRowPropsToJson(
    UikTwoComponentRowProps entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['action'] = entity.action.toJson();
  return data;
}
